#! /bin/sh -efu

#
# Moodle install tools
#
# @package   mt-install
# @copyright 2012 Aleksey Avdeev <solo@altlinux.ru>
# @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v2 or later
#

PROG="${0##*/}"

PATH="%_sbindir:$PATH"

moodledir='%moodle_dir'

. shell-error

TEMP=`getopt -n "$PROG" -o m: -l moodledir: -- "$@"`
eval set -- "$TEMP"

while :; do
	case "$1" in
		--)
			shift
			break
			;;
		-m|--moodledir)
			shift
			moodledir="$1"
			;;
		*) fatal "Unrecognized option: $1"
			;;
	esac
	shift
done

cd "$moodledir/lang"
find . -mindepth 1 -maxdepth 1 -type d -printf '%f\n' \
	| while read -r lang
do
	if [ -n "$lang" ]; then
		langname=`mt-getthislanguage "$lang" 2>/dev/null ||:`
		if [ -n "$langname" ]; then
			printf "%s\t%s\n" "$lang" "$langname"
		fi
	fi
done
