#! /bin/sh -efu

#
# Moodle install tools
#
# @package   mt-install
# @copyright 2012 Aleksey Avdeev <solo@altlinux.ru>
# @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v2 or later
#

PROG="${0##*/}"

wwwroot=

. shell-error

TEMP=`getopt -n "$PROG" -o w: -l wwwroot: -- "$@"`
eval set -- "$TEMP"

while :; do
	case "$1" in
		--)
			shift
			break
			;;
		-w|--wwwroot)
			shift
			wwwroot="$1"
			;;
		*) fatal "Unrecognized option: $1"
			;;
	esac
	shift
done

if [ -n "$wwwroot" ]; then
	echo $wwwroot \
	| sed -rn 's@^[[:space:]]*[a-zA-Z]+://[^[:space:]:/]+(:[^/]+)?/([^[:space:]]*)[[:space:]]*$@\2@p'
else
	fatal "No set --wwwroot"
fi
